 /*   First version:  02/02/2016, Yury Vilk. 

   Usage:

%LET m_vars_list=%SYSFUNC(COMPBL(reg_ds_in independent_vars dependent_vars freq weight noint  
								                        runid iter_nb prefix last_iter_in  last_runid_in end_job_dp_in));

   %create_parameters_tbl(m_vars_list=&m_vars_list.
										   ,tbl_name_out=DPLocal.&prefix.VARS_NM_VALUE_PAIRS
										  ,tbl_name_out2=INFOLDER.VARS_NM_VALUE_PAIRS
										  ,m_vars_list_for_client="runid" "iter_nb" "prefix" "end_job_dp_in"
										  ,file_nm_out=&infolder_dir.vars_nm_value_pairs_for_client.csv
                                           );
*/

%MACRO create_parameters_tbl(m_vars_list=
                                                     ,tbl_name_out=VARS_NM_VALUE_PAIRS
                                                     ,tbl_name_out2=
													,m_vars_list_for_client=
													,file_nm_out=vars_nm_value_pairs_for_client.csv
                                                     ) ;

  %PUT;
   %PUT -----   Start of the macro create_parameters_tbl;
   %PUT;

DATA &tbl_name_out.(COMPRESS=YES);
LENGTH M_VAR_ID 3 M_VAR_NM $ 32 m_vars_list $ 32000 m_var_value $ 32000;
		  /* m_vars_list=lowcase("&m_vars_list.");*/
		   m_vars_list=lowcase(COMPBL(SYMGET("m_vars_list")));
  		   count_m_vars_list=COUNTW(STRIP(m_vars_list)," ")	;

	DO  i=1 TO count_m_vars_list;
	   M_VAR_ID=i;
	   M_VAR_NM=SCAN(STRIP(m_vars_list),i);
	   IF SYMEXIST(M_VAR_NM)=0 THEN M_VAR_VALUE="";
	   ELSE M_VAR_VALUE=STRIP(LOWCASE(SYMGET(M_VAR_NM)));
	    OUTPUT;
	END;
  KEEP  M_VAR_ID M_VAR_NM M_VAR_VALUE;
RUN;

%IF %LENGTH(&tbl_name_out2.) >0 %THEN 
              %DO;
 DATA &tbl_name_out2.(COMPRESS=YES);
  	 SET  &tbl_name_out.;
 RUN;
	          %END;

	
DATA  _VARS_NM_VALUE_PAIRS_FOR_CLIENT(COMPRESS=YES);
  SET &tbl_name_out.(KEEP=M_VAR_NM m_var_value);
  IF LOWCASE(M_VAR_NM) IN ("" &m_vars_list_for_client.);
 RUN;

 %IF %LENGTH(&m_vars_list_for_client.) >0 %THEN 
              %DO;
/*	
PROC EXPORT DATA=_VARS_NM_VALUE_PAIRS_FOR_CLIENT
     OUTFILE="&file_nm_out."
     DBMS=CSV 
     REPLACE;
RUN;
*/

%export_sas_to_dlm_txt(tbl_name_in=_vars_nm_value_pairs_for_client
                                          ,file_name_out=&file_nm_out.);
			   %END;

	%PUT;
   %PUT -----   End of the macro create_parameters_tbl;
   %PUT;
 %MEND;



 

